
.include "m8def.inc"	;AT8-16, 4


.org 0				; 
	rjmp start
.org 6				;Output Compare1A Interrupt Vector Address
	rjmp timer1compare
.org 7				;Output Compare1B Interrupt Vector Address
	rjmp timer2compare
.org 8				; timer1
	rjmp timer1
.org 14				;. 
	rjmp adc_complete;  ( )


start:
;====================
ldi R16, low(RAMEND) ; 
out SPL, R16 
ldi R16, high(RAMEND); 
out SPH, R16
;==== ====
ldi R16, 0b00000011
out ddrC, R16		;P
ldi R16, 0b11111100
out PortC, R16		; 
ldi R16, 0b00000000
out ddrD, R16		;PD0   
ldi R16, 0b00000001
out PortD, R16		; 
;================
clr R2				;"0",  
clr R4				;  
clr R5				;   x%
clr R6				;   x%
clr R7				;OCR1AH
clr R8				;OCR1AL
clr R9				;TCNT1H
clr R10				;TCNT1L
clr R11				;
clr R15				; sreg,
clr R17				;2
clr R18				;   .1
clr R19				;   .2
clr R20				; 
clr R21				;    
clr R25				;   
clr R26				; "lowX", ,LD
clr R27				;POH "highX", ,LD
;===  ===
rcall FuozTable1
rcall FuozTable2
rcall FuozTable3	;   
;========Timer+ADC=======
ldi R16, 0b00000010	; 8,   4
out TCCR1B, R16 	;  16-
ldi R16, 0b00011100
out TIMSK, R16 		; 16- 
ldi R16, 0b01100010	;AD_Converter ADMUX byte
out ADMUX, R16
ldi R16, 0b10001101	;AD_Converter ADCSRA byte,125kHz
out ADCSRA, R16		;   800, 416
sei 				;.   
;==  ,   ==

main:
;  ,  
;      
sbic PinC,0		;    "1"
inc R18			;+1
cpi R18, 15		;  "1" ""
brlo main2		;  
;  , 
cbi PortC,0		;"0"  "", 
clr R18			;   
main2:

sbic PinC,1		;    "1"
inc R19			;+1
cpi R19, 15		;  "1" ""
brlo main3		;  
;  ,  
cbi PortC,1		;"0"  "", 
clr R19			;   
main3:

; 
sbic PinD,0		;    "1"
rcall noimpuls

;  
sbis PinD,0		;    "0"
rcall impuls

sbrs R20, 5		;if pinX,n='0' then do
rjmp main
sbrc R20, 7		;if pinX,n='1' then do
rcall holostie
sbrs R20, 7		;if pinX,n='0' then do
rcall norm

rjmp main
nop
nop
nop
;-------------------------------------------------------------
;----------------  --------------------
;-------------------------------------------------------------
;== 16- ==
;      480/
timer1:
in R15,SREG		; SREG
ori R20, 0b10000000	;sbiR20/7, 
out SREG,R15	; SREG
reti


;=  OCR1A, 16- =
;   
timer1compare:
in R15,SREG		; SREG
sbrs R20, 4		;if pinX,n='0' then do
reti
sbi PortC,0		;"1"  "", 
andi R20, 0b11101111;cbiR20/4, 
out SREG,R15	; SREG
reti


;=  OCR1B, 16- =
;   
timer2compare:
in R15,SREG		; SREG
sbrs R20, 2		;if pinX,n='0' then do
reti
sbi PortC,1		;"1"  "", 
andi R20, 0b11111011;cbiR20/2, 
out SREG,R15	; SREG
reti


;====  ====
adc_complete:
in R11, ADCL	
in R11, ADCH
lsr R11			;1/2=128
lsr R11			;1/2=64
lsr R11			;1/2=32
ori R20, 0b00000010;sbiR20/1,,
reti


;====  ====
impuls:
sbrc R20, 6		;if pinX,n='1' then do
ret				;     
in R10, TCNT1L
in R9, TCNT1H	;  
out TCNT1H, R2	;R2=0
out TCNT1L, R2	; 
ori R20, 0b01100000	;sbiR20/6,5, 
;  ,  
; 2 ,     
;    
sbrs R20, 4		;if pinX,n='0' then do
ret				;   
sbi PortC,0		;"1"  "", 
andi R20, 0b11101111;cbiR20/4, 
ret


;== ,  ==
noimpuls:
andi R20, 0b10111111;cbiR20/6, 
ret


;==== =====
;=  =
norm:
mov R21, R9		;   16-,Hbyte
com R21			; 
;  255   ,
;  -  ,  - 
;     
;   ,  
///////////////////////////////////////////////////
cpi R21, 249	;   
brsh rpm19k5	;   
cpi R21, 248	;   
brsh rpm16k7	;   
cpi R21, 247	;   
brsh rpm14k6	;   
cpi R21, 246	;   
brsh rpm13k		;   
cpi R21, 245	;   
brsh rpm11k7	;   
cpi R21, 244	;   
brsh rpm10k6	;   
cpi R21, 243	;   
brsh rpm9k7		;   
cpi R21, 242	;   
brsh rpm9k		;   
cpi R21, 241	;   
brsh rpm8k3		;   
cpi R21, 240	;   
brsh rpm7k8		;   
cpi R21, 239	;   
brsh rpm7k3		;   
cpi R21, 238	;   
brsh rpm6k9		;   
cpi R21, 237	;   
brsh rpm6k5		;   
cpi R21, 236	;   
brsh rpm6k1		;   
cpi R21, 234	;   
brsh rpm5k6		;   
cpi R21, 232	;   
brsh rpm5k1		;   
cpi R21, 230	;   
brsh rpm4k7		;   
cpi R21, 227	;   
brsh rpm4k2		;   
cpi R21, 225	;   
brsh rpm3k9		;   
cpi R21, 222	;   
brsh rpm3k5		;   
cpi R21, 216	;   
brsh rpm3k		;   
cpi R21, 213	;   
brsh rpm2k8		;   
cpi R21, 208	;   
brsh rpm2k5		;   
cpi R21, 202	;   
brsh rpm2k2		;   
cpi R21, 197	;   
brsh rpm2k		;   
cpi R21, 190	;   
brsh rpm1k8		;   
cpi R21, 177	;   
brsh rpm1k5		;   
cpi R21, 158	;   
brsh rpm1k2		;   
cpi R21, 138	;   
brsh rpm1k		;   
cpi R21, 110	;   
brsh rpm0k8		;   
cpi R21, 60		;   
brsh rpm0k6		;   
clr R26			; 500   /
rjmp RpmEnd		; 32
////////////////////////////////////////////////////////
rpm19k5:		;
ldi R26, 0x1F	;   "low"
rjmp RpmEnd		; ""
rpm16k7:
ldi R26, 0x1E
rjmp RpmEnd
rpm14k6:
ldi R26, 0x1D
rjmp RpmEnd
rpm13k:
ldi R26, 0x1C
rjmp RpmEnd
rpm11k7:
ldi R26, 0x1B
rjmp RpmEnd
rpm10k6:
ldi R26, 0x1A
rjmp RpmEnd
rpm9k7:
ldi R26, 0x19
rjmp RpmEnd
rpm9k:
ldi R26, 0x18
rjmp RpmEnd
rpm8k3:
ldi R26, 0x17
rjmp RpmEnd
rpm7k8:
ldi R26, 0x16
rjmp RpmEnd
rpm7k3:
ldi R26, 0x15
rjmp RpmEnd
rpm6k9:
ldi R26, 0x14
rjmp RpmEnd
rpm6k5:
ldi R26, 0x13
rjmp RpmEnd
rpm6k1:
ldi R26, 0x12
rjmp RpmEnd
rpm5k6:
ldi R26, 0x11
rjmp RpmEnd
rpm5k1:
ldi R26, 0x10
rjmp RpmEnd
rpm4k7:
ldi R26, 0x0F
rjmp RpmEnd
rpm4k2:
ldi R26, 0x0E
rjmp RpmEnd
rpm3k9:
ldi R26, 0x0D
rjmp RpmEnd
rpm3k5:
ldi R26, 0x0C
rjmp RpmEnd
rpm3k:
ldi R26, 0x0B
rjmp RpmEnd
rpm2k8:
ldi R26, 0x0A
rjmp RpmEnd
rpm2k5:
ldi R26, 0x09
rjmp RpmEnd
rpm2k2:
ldi R26, 0x08
rjmp RpmEnd
rpm2k:
ldi R26, 0x07
rjmp RpmEnd
rpm1k8:
ldi R26, 0x06
rjmp RpmEnd
rpm1k5:
ldi R26, 0x05
rjmp RpmEnd
rpm1k2:
ldi R26, 0x04
rjmp RpmEnd
rpm1k:
ldi R26, 0x03
rjmp RpmEnd
rpm0k8:
ldi R26, 0x02
rjmp RpmEnd
rpm0k6:
ldi R26, 0x01
rjmp RpmEnd
;  "low" 
;  00100-0011F,32
RpmEnd:

;    "0"
;   
ldi R27, 0x01	; "highX"1
sbis PinC,5		;    "0"
ldi R27, 0x02	; "highX"2
sbis PinC,4		;    "0"
ldi R27, 0x03	; "highX"3
;  "High" ,  
ld R25, X		;  -R27:26   25


; :
;sbi ADCSRA,6	;  
;sbrs R20, 1		;if pinX,n='0' then do
;rjmp dalee
;mov R17,R11
;andi R20, 0b11111101;cbiR20/1, 
;dalee:
; 
;cpi R17,16
;brlo plus
;minus:
;mov R16,R17
;subi R16,16		;0...15
;sub R25,R16		;""  
;rjmp next
;plus:
;ldi R16,15
;sub R16,R17		;,0...15
;add R25,R16
;next:


;   , 
;   4
;     ,20
cpi R25, 0x01	;"1"
brlo iskra		;  "0",  

;    DD,=154
;    
;     
cpi R25, 0xDD	;221*0.7=154
brlo raschet	; ,    
;   
sbrs R20, 3		;if pinX,n='0' then do
sbi PortC,0		;"1"  "", 
;   "" 
mov R5, R9		;  16-,H
mov R6, R10		;  16-,L
lsr R5			;1/2, 
ror R6			; 360/512=0.7
com R25			; 
;========:R5R6*R25=R7R8===============
mul R5,R25		;  
mov R8,R0
mov R7,R1
mul R6,R25		;  
add R8,R1
adc R7,R2		;R2=0
;  R7R8  
;      
sub R10,R8		;-R7R8
sbc R9,R7
out OCR1AH, R9	;HighByte
out OCR1AL, R10	;LowByte
;      
;sub R6,R8		;1/2-R7R8
;sbc R5,R7
;out OCR1BH, R5	;HighByte
;out OCR1BL, R6	;LowByte
ori R20, 0b00011000	;sbiR20/43, 
andi R20, 0b11011111;cbiR20/5, 
ret


raschet:
;   ""
mov R5, R9		;  16-,H
mov R6, R10		;  16-,L
lsr R5			;1/2, 
ror R6			; 360/512=0.7
;========:R5R6*R25=R7R8===============
mul R5,R25		;  
mov R8,R0
mov R7,R1
mul R6,R25		;  
add R8,R1
adc R7,R2		;R2=0
;  R7R8  
;      
out OCR1AH, R7	;HighByte
out OCR1AL, R8	;LowByte
;      
;add R6,R8		;+1/2 
;adc R5,R7
;out OCR1BH, R5	;HighByte
;out OCR1BL, R6	;LowByte
ori R20, 0b00010000	;sbiR20/4, 
andi R20, 0b11010111;cbiR20/53, 
ret


;======  ,   =======
;      
;       
iskra:
sbrs R20, 3		;if pinX,n='0' then do
sbi PortC,0		;"1"  "", 
;    
;mov R5, R9		;  16-,HighByte
;mov R6, R10		;  16-,LowByte
;lsr R5			;1/2  4.
;ror R6			;180
;lsr R5			;1/4
;ror R6			;90
;    
;out OCR1BH, R5	;HighByte
;out OCR1BL, R6	;LowByte
;ori R20, 0b00000100	;sbiR20/2, 
andi R20, 0b11010111;cbiR20/53, 
ret


;==() ==
;    
;    460/
;    
;      
;  4,  
holostie:
ser R16			;=0xFF
mov R9, R16		;  500/
mov R10, R16	; .
andi R20, 0b01111111;cbiR20/7, 
ret


///////////////////////////////////////////////////////////
;  , 20
;R20/7- ,  16- 
;R20/6-   , -1,  
;R20/5-   , -2,  
;R20/4-  , . , 
;R20/3-    0x1FF, 
;R20/2-. , 
;R20/1-,, 
///////////////////////////////////////////////////////////


;== 1,   ==
;=======  20,  0.7=======
FuozTable1:
ldi R27, 0x01	; "highX"=01
ldi R26, 0x00	; "lowX"=00
;  
;500  , /
ldi R16, 30	;
st X+, R16	; , -1
;600 /
ldi R16, 28	;
st X+, R16	; ,0.4
;800 /
ldi R16, 26	;
st X+, R16	; ,  2
;1000 /
ldi R16, 21	;
st X+, R16	; ,  5
;1200 /
ldi R16, 18	;
st X+, R16	; ,  8
;1500 /
ldi R16, 16	;
st X+, R16	; , 10
;1800 /
ldi R16, 14	;
st X+, R16	; , 11
;2000 /
ldi R16, 12	;
st X+, R16	; , 12
;2200 /
ldi R16, 10	;
st X+, R16	; , 13
;2500 /
ldi R16, 8	;
st X+, R16	; , 14
;2800 /
ldi R16, 6	;
st X+, R16	; , 16
;3000 /
ldi R16, 4	;
st X+, R16	; , 17
;3500 /
ldi R16, 3	;
st X+, R16	; , 18
;3900 /
ldi R16, 2	;
st X+, R16	; , 19
;4200 /
ldi R16, 1	;
st X+, R16	; , 19
;4700 /
ldi R16, 0	;
st X+, R16	; , 20.0
;5100 /
ldi R16, 254;
st X+, R16	; , 21.4
;5600 /
ldi R16, 253;
st X+, R16	; , 22.1
;6100 /
ldi R16, 252;
st X+, R16	; , 22.8
;6500 /
ldi R16, 251;
st X+, R16	; , 23.5
;6900 /
ldi R16, 251;
st X+, R16	; , 23.5
;7300 /
ldi R16, 250;
st X+, R16	; , 24.2
;7800 /
ldi R16, 250;
st X+, R16	; , 24.2
;8300 /
ldi R16, 249;
st X+, R16	; , 24.9
;9000 /
ldi R16, 249;
st X+, R16	; , 24.9
;9700 /
ldi R16, 249;
st X+, R16	; , 24.9
;10600 /
ldi R16, 249;
st X+, R16	; , 24.9
;11700 /
ldi R16, 249;
st X+, R16	; , 24.9
;13000 /
ldi R16, 249;
st X+, R16	; , 24.9
;14600 /
ldi R16, 249;
st X+, R16	; , 24.9
;16700 /
ldi R16, 249;
st X+, R16	; , 24.9
;19500 /
ldi R16, 249;
st X, R16	; , 24.9
ret		;  

;== 2,   ==
;=======  20,  0.7=======
FuozTable2:
ldi R27, 0x02	; "highX"=02
ldi R26, 0x00	; "lowX"=00
;  
;500  , /
ldi R16, 30	;
st X+, R16	; , -1
;600 /
ldi R16, 28	;
st X+, R16	; ,0.4
;800 /
ldi R16, 26	;
st X+, R16	; ,  2
;1000 /
ldi R16, 21	;
st X+, R16	; ,  5
;1200 /
ldi R16, 18	;
st X+, R16	; ,  7
;1500 /
ldi R16, 16	;
st X+, R16	; ,  9
;1800 /
ldi R16, 14	;
st X+, R16	; , 10
;2000 /
ldi R16, 12	;
st X+, R16	; , 11
;2200 /
ldi R16, 10	;
st X+, R16	; , 13
;2500 /
ldi R16, 8	;
st X+, R16	; , 14
;2800 /
ldi R16, 6	;
st X+, R16	; , 16
;3000 /
ldi R16, 4	;
st X+, R16	; , 17
;3500 /
ldi R16, 3	;
st X+, R16	; , 18
;3900 /
ldi R16, 2	;
st X+, R16	; , 19
;4200 /
ldi R16, 1	;
st X+, R16	; , 19
;4700 /
ldi R16, 0	;
st X+, R16	; , 20.0
;5100 /
ldi R16, 0	;
st X+, R16	; , 20.0
;5600 /
ldi R16, 0	;
st X+, R16	; , 20.0
;6100 /
ldi R16, 0	;
st X+, R16	; , 20.0
;6500 /
ldi R16, 0	;
st X+, R16	; , 20.0
;6900 /
ldi R16, 0	;
st X+, R16	; , 20.0
;7300 /
ldi R16, 0	;
st X+, R16	; , 20.0
;7800 /
ldi R16, 0	;
st X+, R16	; , 20.0
;8300 /
ldi R16, 0	;
st X+, R16	; , 20.0
;9000 /
ldi R16, 0	;
st X+, R16	; , 20.0
;9700 /
ldi R16, 0	;
st X+, R16	; , 20.0
;10600 /
ldi R16, 0	;
st X+, R16	; , 20.0
;11700 /
ldi R16, 0	;
st X+, R16	; , 20.0
;13000 /
ldi R16, 0	;
st X+, R16	; , 20.0
;14600 /
ldi R16, 0	;
st X+, R16	; , 20.0
;16700 /
ldi R16, 0	;
st X+, R16	; , 20.0
;19500 /
ldi R16, 0	;
st X, R16	; , 20.0
ret		;  

;== 3,   ==
;=======  20,  0.7=======
FuozTable3:
ldi R27, 0x03	; "highX"=03
ldi R26, 0x00	; "lowX"=00
;  
;500  , /
ldi R16, 0	;
st X+, R16	; , 20.0
;600 /
ldi R16, 0	;
st X+, R16	; , 20.0
;800 /
ldi R16, 0	;
st X+, R16	; , 20.0
;1000 /
ldi R16, 0	;
st X+, R16	; , 20.0
;1200 /
ldi R16, 0	;
st X+, R16	; , 20.0
;1500 /
ldi R16, 0	;
st X+, R16	; , 20.0
;1800 /
ldi R16, 0	;
st X+, R16	; , 20.0
;2000 /
ldi R16, 0	;
st X+, R16	; , 20.0
;2200 /
ldi R16, 0	;
st X+, R16	; , 20.0
;2500 /
ldi R16, 0	;
st X+, R16	; , 20.0
;2800 /
ldi R16, 0	;
st X+, R16	; , 20.0
;3000 /
ldi R16, 0	;
st X+, R16	; , 20.0
;3500 /
ldi R16, 0	;
st X+, R16	; , 20.0
;3900 /
ldi R16, 0	;
st X+, R16	; , 20.0
;4200 /
ldi R16, 0	;
st X+, R16	; , 20.0
;4700 /
ldi R16, 0	;
st X+, R16	; , 20.0
;5100 /
ldi R16, 0	;
st X+, R16	; , 20.0
;5600 /
ldi R16, 0	;
st X+, R16	; , 20.0
;6100 /
ldi R16, 0	;
st X+, R16	; , 20.0
;6500 /
ldi R16, 0	;
st X+, R16	; , 20.0
;6900 /
ldi R16, 0	;
st X+, R16	; , 20.0
;7300 /
ldi R16, 0	;
st X+, R16	; , 20.0
;7800 /
ldi R16, 0	;
st X+, R16	; , 20.0
;8300 /
ldi R16, 0	;
st X+, R16	; , 20.0
;9000 /
ldi R16, 0	;
st X+, R16	; , 20.0
;9700 /
ldi R16, 0	;
st X+, R16	; , 20.0
;10600 /
ldi R16, 0	;
st X+, R16	; , 20.0
;11700 /
ldi R16, 0	;
st X+, R16	; , 20.0
;13000 /
ldi R16, 0	;
st X+, R16	; , 20.0
;14600 /
ldi R16, 0	;
st X+, R16	; , 20.0
;16700 /
ldi R16, 0	;
st X+, R16	; , 20.0
;19500 /
ldi R16, 0	;
st X, R16	; , 20.0
ret		;  
